Index: trunk/pbs_drmaa/pbs_drmaa.h
===================================================================
--- trunk/pbs_drmaa/pbs_drmaa.h	(revision 1)
+++ trunk/pbs_drmaa/pbs_drmaa.h	(revision 1)
@@ -0,0 +1,120 @@
+/* $Id: pbs_drmaa.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ *  FedStage DRMAA for PBS Pro
+ *  Copyright (C) 2006-2007  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __DRMAA__PBS_DRMAA_H
+#define __DRMAA__PBS_DRMAA_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <sys/types.h>
+#include <stdbool.h>
+#include <time.h>
+#include <pbs_ifl.h>
+
+#include <drmaa_utils/common.h>
+#include <pbs_drmaa/pbs_attrib.h>
+
+
+/** PBS DRMAA specific session data. */
+struct drmaa_session_impl_s {
+	int                 pbs_conn;    /**< PBS connection (or -1). */
+	drmaa_mutex_t       conn_mutex;  /**< Mutex for PBS connection. */
+	drmaa_thread_t      wait_thread;
+	bool                wait_thread_started;
+	struct attrl       *status_attrl;
+};
+
+
+enum { PBS_ATTRIBS_BITSET_SIZE = (N_PBS_DRMAA_ATTRIBS+31) / 32 };
+struct drmaa_submit_impl_s {
+	struct attrl *pbs_attribs;
+	uint32_t pbs_attribs_bitset[ PBS_ATTRIBS_BITSET_SIZE ];
+	char *script_filename;
+};
+
+
+void *
+drmaa_wait_thread( void *arg );
+
+drmaa_submit_ctx_t *
+drmaa_create_submission_context(
+		const drmaa_job_template_t *jt, int bulk_no,
+		drmaa_err_ctx_t *err
+		);
+
+void
+drmaa_free_submission_context( drmaa_submit_ctx_t *c, drmaa_err_ctx_t* );
+
+void drmaa_set_job_defaults        ( drmaa_submit_ctx_t*, drmaa_err_ctx_t* );
+void drmaa_create_job_script       ( drmaa_submit_ctx_t*, drmaa_err_ctx_t* );
+void drmaa_set_job_submit_state    ( drmaa_submit_ctx_t*, drmaa_err_ctx_t* );
+void drmaa_set_job_files           ( drmaa_submit_ctx_t*, drmaa_err_ctx_t* );
+void drmaa_set_file_staging        ( drmaa_submit_ctx_t*, drmaa_err_ctx_t* );
+void drmaa_set_job_resources       ( drmaa_submit_ctx_t*, drmaa_err_ctx_t* );
+void drmaa_set_job_environment     ( drmaa_submit_ctx_t*, drmaa_err_ctx_t* );
+void drmaa_set_job_email_notif     ( drmaa_submit_ctx_t*, drmaa_err_ctx_t* );
+void drmaa_apply_native_spec       ( drmaa_submit_ctx_t*, drmaa_err_ctx_t* );
+void drmaa_apply_job_category      ( drmaa_submit_ctx_t*, drmaa_err_ctx_t* );
+char *drmaa_translate_staging( const char *stage, drmaa_err_ctx_t* );
+
+void
+drmaa_parse_qsub_args(
+		drmaa_submit_ctx_t *ctx, const char *string,
+		drmaa_err_ctx_t *err
+		);
+
+void
+drmaa_job_missing( drmaa_job_t *job, drmaa_err_ctx_t *err );
+
+void
+drmaa_add_pbs_attr(
+		drmaa_submit_ctx_t *c,
+		int attr, char *resource, char *value,
+		unsigned set,
+		drmaa_err_ctx_t *err
+		);
+
+char *
+drmaa_write_tmpfile(
+	 const char *content, size_t len,
+	 drmaa_err_ctx_t *err
+	 );
+
+struct attrl *
+drmaa_create_pbs_attrl( drmaa_err_ctx_t *err );
+
+void
+drmaa_log_attrl( const struct attrl *attribute_list, const char *prefix );
+
+void
+drmaa_free_attrl( struct attrl *attr );
+
+void
+drmaa_err_pbs_error( drmaa_err_ctx_t *err );
+
+int
+drmaa_err_map_pbs_error( int pbs_errcode );
+
+#define RAISE_PBS() \
+	drmaa_err_pbs_error( err )
+
+#endif /* __DRMAA__PBS_DRMAA_H */
+
Index: trunk/pbs_drmaa/pbs_attrib.h
===================================================================
--- trunk/pbs_drmaa/pbs_attrib.h	(revision 104)
+++ trunk/pbs_drmaa/pbs_attrib.h	(revision 1)
@@ -1,3 +1,3 @@
-/* $Id$ */
+/* $Id: pbs_attrib.h 256 2010-08-10 16:31:35Z mamonski $ */
 /*
  *  FedStage DRMAA for PBS Pro
@@ -41,5 +41,4 @@
 #define PBSDRMAA_FILE_SIZE_LIMIT        "Resource_List.file"
 #define PBSDRMAA_NICE                   "Resource_List.nice"
-#define PBSDRMAA_MEM_LIMIT              "Resource_List.mem"
 #define PBSDRMAA_VMEM_LIMIT             "Resource_List.vmem"
 #define PBSDRMAA_SINGLE_CPU_TIME_LIMIT  "Resource_List.pcput"
@@ -51,8 +50,4 @@
 #define PBSDRMAA_NODES                  "Resource_List.nodes"
 #define PBSDRMAA_SOFTWARE               "Resource_List.software"
-#define PBSDRMAA_PLACE                  "Resource_List.place"
-#define PBSDRMAA_SELECT                 "Resource_List.select"
-#define PBSDRMAA_PROCS                  "Resource_List.procs"
-#define PBSDRMAA_NCPUS                  "Resource_List.ncpus"
 #define PBSDRMAA_MAIL_POINTS            "Mail_Points"
 #define PBSDRMAA_OUTPUT_PATH            "Output_Path"
@@ -74,5 +69,4 @@
 /* additional job and general attribute names */
 #define PBSDRMAA_EXECUTION_HOST         "exec_host"
-#define PBSDRMAA_EXECUTION_VNODE        "exec_vnode" /* PBS PRO */
 #define PBSDRMAA_JOB_OWNER              "Job_Owner"
 #define PBSDRMAA_RESOURCES_USED         "resources_used"
@@ -81,16 +75,9 @@
 #define PBSDRMAA_SERVER                 "server"
 #define PBSDRMAA_COMMENT                "comment"
+#define PBSDRMAA_EXIT_STATUS            "exit_status"
 #define PBSDRMAA_START_TIME             "start_time"
 #define PBSDRMAA_EXTENSION              "extension"
-#define PBSDRMAA_SUBMIT_ARGS            "submit_args"
-#define PBSDRMAA_MTIME                  "mtime"
-#define PBSDRMAA_NODE_PROPERTIES        "pbsdrmaa.node_properties"
-#define PBSDRMAA_CUSTOM_RESOURCES       "pbsdrmaa.custom_resources"
+#define PBSDRMAA_SUBMIT_ARGS		"submit_args"
 
-#ifdef PBS_PROFESSIONAL
-#	define PBSDRMAA_EXIT_STATUS        	"Exit_status"
-#else
-#	define PBSDRMAA_EXIT_STATUS        	"exit_status"
-#endif
 
 typedef enum {
@@ -107,5 +94,4 @@
 	PBSDRMAA_ATTR_NICE,
 	PBSDRMAA_ATTR_VMEM_LIMIT,
-	PBSDRMAA_ATTR_MEM_LIMIT,
 	PBSDRMAA_ATTR_SINGLE_CPU_TIME_LIMIT,
 	PBSDRMAA_ATTR_SINGLE_RSS_LIMIT,
@@ -115,9 +101,5 @@
 	PBSDRMAA_ATTR_HOST,
 	PBSDRMAA_ATTR_NODES,
-	PBSDRMAA_ATTR_PROCS,
-	PBSDRMAA_ATTR_NCPUS,
 	PBSDRMAA_ATTR_SOFTWARE,
-	PBSDRMAA_ATTR_PLACE,
-	PBSDRMAA_ATTR_SELECT,
 	PBSDRMAA_ATTR_MAIL_POINTS,
 	PBSDRMAA_ATTR_OUTPUT_PATH,
@@ -139,5 +121,4 @@
 	/* additional job and general attribute names */
 	PBSDRMAA_ATTR_EXECUTION_HOST,
-	PBSDRMAA_ATTR_EXECUTION_VNODE, /* PBS PRO */
 	PBSDRMAA_ATTR_JOB_OWNER,
 	PBSDRMAA_ATTR_RESOURCES_USED,
@@ -151,6 +132,61 @@
 	PBSDRMAA_ATTR_SUBMIT_ARGS,
 	PBSDRMAA_ATTR_MTIME,
-	PBSDRMAA_ATTR_NODE_PROPERTIES,
-	PBSDRMAA_ATTR_CUSTOM_RESOURCES,
+
+#if 0
+	/* Additional Torque/OpenPBS attribs (not in DRMAA specification): */
+	/* Used by OpenPBS user commands: */
+	PBSDRMAA_ATTR_CHECKPOINT = DRMAA_N_ATTRIBUTES, /* MAX_DRMAA_ATTR+1, */
+	PBSDRMAA_ATTR_GROUP_LIST,
+	PBSDRMAA_ATTR_HOLD_TYPES,
+	PBSDRMAA_ATTR_KEEP_FILES,
+	PBSDRMAA_ATTR_RESOURCES,
+	PBSDRMAA_ATTR_MAIL_POINTS,
+	PBSDRMAA_ATTR_PRIORITY,
+	PBSDRMAA_ATTR_DESTINATION_QUEUE,
+	PBSDRMAA_ATTR_RERUNABLE,
+	PBSDRMAA_ATTR_USER_LIST,
+	PBSDRMAA_ATTR_ACCOUNT_NAME,
+	PBSDRMAA_ATTR_SHELL,
+	PBSDRMAA_ATTR_DEPENDENCIES,
+	PBSDRMAA_ATTR_INTERACTIVE,
+	PBSDRMAA_ATTR_STAGEIN,
+	PBSDRMAA_ATTR_STAGEOUT,
+
+	/* Additional job and general attribute names: */
+	PBSDRMAA_ATTR_JOB_STATE,
+	PBSDRMAA_ATTR_CTIME,
+	/* PBSDRMAA_ATTR_MTIME, moved to basic attributes - needed to determine job end time*/
+	PBSDRMAA_ATTR_QTIME,
+	PBSDRMAA_ATTR_ETIME,
+	PBSDRMAA_ATTR_RESOURCES_USED,
+	PBSDRMAA_ATTR_EXIT_STATUS,
+	PBSDRMAA_ATTR_JOB_OWNER,
+	PBSDRMAA_ATTR_EUSER,
+	PBSDRMAA_ATTR_EGROUP,
+	PBSDRMAA_ATTR_HOP_COUNT,
+	PBSDRMAA_ATTR_SECURITY,
+	PBSDRMAA_ATTR_SCHEDULER_HINT,
+	PBSDRMAA_ATTR_SERVER,
+	PBSDRMAA_ATTR_QUEUE,
+	PBSDRMAA_ATTR_QUEUE_RANK,
+	PBSDRMAA_ATTR_EXECUTION_HOST,
+	PBSDRMAA_ATTR_TOTAL_JOBS,
+	PBSDRMAA_ATTR_MAX_RUNNING,
+	PBSDRMAA_ATTR_COMMENT,
+	PBSDRMAA_ATTR_JOB_COOKIE,
+	PBSDRMAA_ATTR_HASHNAME,
+	PBSDRMAA_ATTR_SESSION_ID,
+	PBSDRMAA_ATTR_ALT_ID,
+
+	/* Reservation attributes */
+	PBSDRMAA_ATTR_RESERVATION_START,
+	PBSDRMAA_ATTR_RESERVATION_END,
+	PBSDRMAA_ATTR_RESERVATION_DURATION,
+	PBSDRMAA_ATTR_RESERVATION_STATE,
+	PBSDRMAA_ATTR_RESERVATION_SUBSTATE,
+
+	/* Pseudo PBS attributes */
+	PBSDRMAA_ATTR_RESERVATION_ID,
+#endif
 
 	PBSDRMAA_N_PBS_ATTRIBUTES
Index: trunk/.svnignore
===================================================================
--- trunk/.svnignore	(revision 46)
+++ trunk/.svnignore	(revision 1)
@@ -1,5 +1,3 @@
 configure
-.project
-.cproject
 Makefile.in
 config.log
@@ -18,5 +16,6 @@
 pbs_attrib.c
 del_all_jobs
-pbs_drmaa-1.0.11.tar.gz
+pbs_drmaa-1.0.2.tar.gz
+pbs_drmaa-1.0.3.tar.gz
 pbs_drmaa
 .svnignore
@@ -34,4 +33,2 @@
 readme.aux
 readme.log
-drmaa-run
-hpc-bash
